/* Header file for the following created by Sevy.
   This code ported to djgpp & otherwise modified by:
   Marp (marp@technologist.com) &
   Sevy (sevy@zophar.net)
   for use with MSP (Miscellaneous Sound Player)
   http://smsoft.zophar.net */

/****************************************************************************
** Demonstration of playing an Audio CD                                    **
**  by Steven H Don                                                        **
**                                                                         **
** For questions, feel free to e-mail me.                                  **
**                                                                         **
**    shd@earthling.net                                                    **
**    http://shd.cjb.net                                                   **
**                                                                         **
****************************************************************************/
#define HIBYTE(x)	((char)(((short)(x) >> 8) & 0x00FF))
#define LOBYTE(x)	((char)(x))

struct CommandStructure {
  unsigned char Length;               /* Length of parameter block */
  unsigned char SUC;                  /* SubUnitCode of CDROM drive,
                                         MSCDEX fills this in for us */
  unsigned char FNr;                  /* Function number */
  unsigned short SW;                  /* Driver returns: Status word */
  unsigned char Unused[9];            /* Unused */
  unsigned short PBOfs;               /* Pointer to control block containing */
  unsigned short PBSeg;               /* data for the specific function call */
} __attribute__((packed)) Command;

/* Structure to receive information on the audio CD */
struct CDInfoStructure {
  unsigned char SubFNr;        /* CDROM driver subfunction */
  unsigned char First;         /* First track */
  unsigned char Last;          /* Last track */
  unsigned long LeadOut;       /* Location of the end of the last track */
} __attribute__((packed));

/* Structure used to receive info on a specific track on the CD */
struct TrackInfoStructure {
  unsigned char SubFNr;               /* SubFunction number */
  unsigned char TrackNr;              /* Track number */
  unsigned long Address;              /* Driver returns: Sector address */
  unsigned char Status;               /* Driver returns: Track status */
} __attribute__((packed));

/* Structure used to start playing an audio track */
struct PlayStructure {
  unsigned char Length;               /* Length of parameter block */
  unsigned char SUC;                  /* SubUnitCode of CDROM drive,
                                         MSCDEX fills this in for us */
  unsigned char FNr;                  /* Function number */
  unsigned short SW;                  /* Driver returns: Status word */
  unsigned char Unused[8];            /* Unused */
  unsigned char Mode;                 /* Addressing mode (Using 1, Red Book) */
  unsigned long Start;                /* Starting sector of the track */
  unsigned long Sectors;              /* Amount of sectors to play */
  /* Bear in mind that one 'sector' equals one 75th of a second */
} __attribute__((packed));

/* Structure used to stop playing an audio track */
struct StopStructure {
  unsigned char Length;               /* Length of parameter block */
  unsigned char SUC;                  /* SubUnitCode of CDROM drive,
                                         MSCDEX fills this in for us */
  unsigned char FNr;                  /* Function number */
  unsigned short SW;                  /* Driver returns: Status word */
};

  unsigned char Number_Of_Players;    /* The amount of players installed */
  unsigned short Drive_Letter;        /* The drive letter of the first player */
  unsigned char First_Track;          /* The first track on the current disc */
  unsigned char Last_Track;           /* The last track on the current disc */
  unsigned long LeadOut_Track;        /* The end of the current disc */
  unsigned short StatusWord;          /* The result of a function call is
                                         stored here */

  unsigned char TrackToPlay;          /* Stores the track the user wants to
                                         play */
  char TrackToPlayASCII[3];           /* Used for keyboard input of the above
                                         value */
  unsigned char Done;                 /* Global indicator */
unsigned char Check_MSCDEX ();
unsigned long HSG (unsigned long RedBook);
void Call_CDROM_Driver(void *DrivParms, int size);
void GetAudioCDInfo ();
void PlayTrack (unsigned char Track);
void StopPlaying ();
unsigned char CheckForErrors ();

