/*
** Nofrendo - NES emulator
** (c) 1999 Matthew Conte
**
** License agreement:
**
** This source code may be distributed in unmodified form to any medium,
** and may be used in any *freeware* project.
**
** It may not be sold, in full or in part, as part of any commercial or
** shareware sofware package without the express written permission of 
** the author, Matthew Conte (matt@conte.com).
**
** Modified versions of this code may not be publicly distributed
** without the submission to, and approval of the author (matt@conte.com).
** This includes distribution in source, object, or binary form.
**
** The author claims no responsibility for damage cause by this code; it
** is distributed "as-is"; in other words, use at your own risk.
**
** Any freeware application using this code must credit the author,
** Matthew Conte, in the application itself or the documentation.
**
** Modifications should be reported to matt@conte.com, to ensure the
** highest degree of quality and accuracy is always freely available.
**
**
** cpu.h
**
** NES CPU definitions
*/

#ifndef _CPU_H_
#define _CPU_H_

#include "nes6502.h"

#define  cpu_context          nes6502_context
#define  cpu_init             nes6502_init
#define  cpu_reset            nes6502_reset
#define  cpu_execute          nes6502_execute
#define  cpu_nmi              nes6502_nmi
#define  cpu_irq              nes6502_irq
#define  cpu_getcycles        nes6502_getcycles
#define  cpu_dma              nes6502_dma
#define  cpu_contextsize()    sizeof(nes6502_context)
#define  cpu_getcontext       nes6502_getcontext
#define  cpu_setcontext       nes6502_setcontext
#define  cpu_readhandler      nes6502_memread
#define  cpu_writehandler     nes6502_memwrite

#define  CPU_RAMSIZE          0x10000

#endif /* _CPU_H_ */

