/*
** Nofrendo - NES emulator
** (c) 1999 Matthew Conte
**
** License agreement:
**
** This source code may be distributed in unmodified form to any medium,
** and may be used in any *freeware* project.
**
** It may not be sold, in full or in part, as part of any commercial or
** shareware sofware package without the express written permission of 
** the author, Matthew Conte (matt@conte.com).
**
** Modified versions of this code may not be publicly distributed
** without the submission to, and approval of the author (matt@conte.com).
** This includes distribution in source, object, or binary form.
**
** The author claims no responsibility for damage cause by this code; it
** is distributed "as-is"; in other words, use at your own risk.
**
** Any freeware application using this code must credit the author,
** Matthew Conte, in the application itself or the documentation.
**
** Modifications should be reported to matt@conte.com, to ensure the
** highest degree of quality and accuracy is always freely available.
**
**
** nsf_play.h
**
** NSF-specific NES hardware definitions
*/

#ifndef _NSF_PLAY_H_
#define _NSF_PLAY_H_

/* 60 Hertz refresh (NTSC) */
#define  NES_APUBASE          (3579545.454 / 2)
#define  REFRESH_RATE         60

#define  NES_SCANLINE_CYCLES  113.66666667
#define  NES_FRAME_CYCLES     (262 * NES_SCANLINE_CYCLES)

enum
{
   SOFT_RESET = 1,
   HARD_RESET
};

#include "nsf.h"

/* Function prototypes */
extern int nes_init(nsf_t *nsf);
extern void nes_shutdown(void);
extern void nes_reset(int reset_type);
extern int nes_emulate(char *filename);

extern void nsf_reset(void);
extern int nes_frame(void);

#endif /* _NSF_PLAY_H_ */
