/*
** Nofrendo - NES emulator
** (c) 1999 Matthew Conte
**
** License agreement:
**
** This source code may be distributed in unmodified form to any medium,
** and may be used in any *freeware* project.
**
** It may not be sold, in full or in part, as part of any commercial or
** shareware sofware package without the express written permission of 
** the author, Matthew Conte (matt@conte.com).
**
** Modified versions of this code may not be publicly distributed
** without the submission to, and approval of the author (matt@conte.com).
** This includes distribution in source, object, or binary form.
**
** The author claims no responsibility for damage cause by this code; it
** is distributed "as-is"; in other words, use at your own risk.
**
** Any freeware application using this code must credit the author,
** Matthew Conte, in the application itself or the documentation.
**
** Modifications should be reported to matt@conte.com, to ensure the
** highest degree of quality and accuracy is always freely available.
**
** 
** vrcvi.h
**
** VRCVI (Konami MMC) sound hardware emulation header
*/

#ifndef _VRCVI_H_
#define _VRCVI_H_

typedef struct 
{
   float phaseacc;
   uint8 reg[3];
   uint8 adder;
} vrcvisquare_t;

typedef struct
{
   float phaseacc;
   int output_acc;
   uint8 reg[3];
   uint8 adder;
} vrcvisawtooth_t;


extern void vrcvi_reset(void);
extern void vrcvi_soundwrite(uint32 address, uint8 value);
extern int8 vrcvi_soundprocess(void);

#endif /* _VRCVI_H_ */
